package com.jiuqi.util.patterns;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import java.util.ArrayList;
import java.util.List;

public final class Wildcard {
  private String pattern;
  
  private List items;
  
  public static final char DEFAULT_WILDCHAR = '%';
  
  public Wildcard(String pattern) {
    this(pattern, '%');
  }
  
  public Wildcard(String pattern, char wildchar) {
    this.items = new ArrayList();
    this.pattern = pattern;
    if (pattern == null || pattern.length() == 0)
      return; 
    int cur = 0;
    StringBuffer buffer = new StringBuffer(pattern.length());
    while (cur < pattern.length()) {
      char ch = pattern.charAt(cur);
      if (ch == wildchar) {
        if (cur < pattern.length() - 1 && pattern.charAt(cur + 1) == wildchar) {
          buffer.append(wildchar);
          cur += 2;
          continue;
        } 
        if (buffer.length() > 0) {
          this.items.add(buffer.toString().toUpperCase());
          buffer.setLength(0);
        } 
        this.items.add(null);
        cur++;
        continue;
      } 
      buffer.append(ch);
      cur++;
    } 
    if (buffer.length() > 0)
      this.items.add(buffer.toString().toUpperCase()); 
  }
  
  public boolean match(String s) {
    if (s == null || this.items.size() == 0)
      return false; 
    return matchFrom(s.toUpperCase(), 0, 0);
  }
  
  private boolean matchFrom(String s, int level, int fromIndex) {
    while (level < this.items.size()) {
      String subStr = this.items.get(level);
      if (subStr == null) {
        level++;
        continue;
      } 
      while (fromIndex < s.length()) {
        int next = s.indexOf(subStr, fromIndex);
        if (next == -1 || (level == 0 && next > 0))
          return false; 
        fromIndex = next + subStr.length();
        if (matchFrom(s, level + 1, fromIndex))
          return true; 
      } 
      return false;
    } 
    if (fromIndex < s.length())
      return (this.items.get(this.items.size() - 1) == null); 
    return true;
  }
  
  public String toString() {
    return this.pattern;
  }
  
  public static boolean match(String s, String pattern) {
    com.jiuqi.util.patterns.Wildcard wildcard = new com.jiuqi.util.patterns.Wildcard(pattern);
    return wildcard.match(s);
  }
  
  public static boolean match(String s, String pattern, char wildchar) {
    com.jiuqi.util.patterns.Wildcard wildcard = new com.jiuqi.util.patterns.Wildcard(pattern, wildchar);
    return wildcard.match(s);
  }
}
